function varargout = Terracem_gui(varargin)
% TERRACEM_GUI MATLAB code for Terracem_gui.fig
%
%%%%%%%%%%%%%%%%%%%%
%to run TERRACEM type this line in the command window:
%>> Terracem_gui
%%%%%%%%%%%%%%%%%%%%
%     
% Begin initialization code - DO NOT EDIT (GUIDE INITIALIZATION)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Terracem_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @Terracem_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%% INTERFACE FUNCTIONS %%

%% Opening function
function Terracem_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% Choose default command line output for Terracem_gui
handles.output = hObject;
set(handles.sureornot,'Value',0)
set(handles.t2,'String','35000');
set(handles.ti,'String','50');
set(handles.t1,'String','0.5');
set(handles.difu,'String','0.8');
set(handles.slope,'String','50');
set(handles.Search_ratio,'String','0.5');
set(handles.edit14,'String','70');
set(handles.edit15,'String','5');
set(handles.resoluti,'String','2');
set(handles.azimuti,'String','300');
set(handles.svpdf,'Value',0);
%set handles for image control in listbox2, all desactivated 
handles.demsel=0;
handles.shadsel=0; 
handles.imsel=0; 
% condition if to check existence of .path file
path = 'terracem_path.mat'; %path file
cdx=pwd; %local directory
%check if path file exist
if exist(fullfile(cdx, 'terracem_path.mat'), 'file')==2     
    load(path) %load path file       
    try
    if pwd==terracem_dir 
        handles.maindir=(terracem_dir);
        handles.stationsdir=stationsdir;
        handles.zone=zoneutm;     
        %set directories readed from terracem_path.mat
        set(handles.fullpath1,'String',handles.maindir) %print terracem directory path in fullpath1 bar
        set(handles.fullpath2,'String',handles.stationsdir) %print stations directory in fullpath2 bar
        set(handles.utmzonen,'String',handles.zone)    
        %prompt message
        Commands=('Welcome to TerraceM. The directories have been automatically loaded, push "Read Inputs" to proceed');
        T = evalc('Commands');
        Tcell = regexp(T, '\n', 'split');
        set(handles.text38,'String',Tcell);    
    else %If path file differs from directory achitecture    
        %prompt message    
        msgbox('Welcome. seems to be an error in the directories, please set manually the directories and UTM zone and press "Read Inputs"');         
    end     
    catch
    msgbox('the path file is corrupt, please introduce again TerraceM inputs folders')
    delete('terracem_path.mat')  
    end
else
    %command window prompt 
    Commands=('Welcome. Set the imput directories for the TerraceM scripts and your stations');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
end  

%load logos
lgt=handles.logotype;
axes (lgt);
[cdata,map] = imread('logo.tif'); 
imshow(cdata,map)

ax1=handles.map;
axes (ax1);
imshow(cdata,map)

handles.edit15=5;
handles.edit14=70;
% Update handles structure
guidata(hObject, handles);

%% outputs function DO NOT EDIT
function varargout = Terracem_gui_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

%% Small logo TerraceM
function logotype_CreateFcn(hObject, eventdata, handles)
handles = guidata(hObject);
handles.logotype=axis;

guidata(hObject, handles);

%% main plot area
function map_CreateFcn(hObject, eventdata, handles)
handles = guidata(hObject);
handles.map=axis;

guidata(hObject, handles);



%% About information display
function about_Callback(hObject, eventdata, handles)

    Commands=('About the authors. Please send us a feedback (jara@geo.uni-potsdam.de)');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
[cdata,map] = imread('About.tif'); 
hold on
figure
imshow(cdata,map)

%% clean project button
function cleanstat_Callback(hObject, eventdata, handles)

Commands=('Debbugging deletes all path.m files in directories. We suggest debugg your project before moving it into a different directory ');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);

station=handles.statsel; %Selected station directory
dirstations=handles.stationsdir; %Stations directory
maindir=handles.maindir;

cd(dirstations)
cd(station)
cdx1=pwd;

if exist(fullfile(cdx1, 'terracem_path.mat'), 'file')==2 
    delete('terracem_path.mat')
end

cd(maindir)
cdx2=pwd;
if exist(fullfile(cdx2, 'terracem_path.mat'), 'file')==2 
    delete ('terracem_path.mat')
end

%% Help buttons 
function pushbutton23_Callback(hObject, eventdata, handles)
msgbox('Swath profile extraction. This is the second step during first-time use of TerraceM. Please select a Station and press the "SWATH PROFILE EXTRACTION" button to start.')

function pushbutton43_Callback(hObject, eventdata, handles)
msgbox('This function needs to be executed each time the profile polygons (Shapefiles) are edited.')

%%
function pushbutton20_Callback(hObject, eventdata, handles)
msgbox('This is the first step to start using TerraceM. Please define the directories.')
guidata(hObject, handles);

%%
function pushbutton21_Callback(hObject, eventdata, handles)
msgbox('Profile selection list. Used to select the profile for analysis and refresh the map viewer. Selected profile will appear in red')

%%
function pushbutton22_Callback(hObject, eventdata, handles)
msgbox('Select the Station to extract the swath profiles, to display the profile list and also to refresh the mapviewer.')

%%
function pushbutton24_Callback(hObject, eventdata, handles)
msgbox('Parameters box. Used to visualize and modify the parameters for the analysis functions. ')

%%
function pushbutton25_Callback(hObject, eventdata, handles)
msgbox('Staircase analysis. This routine extimates the shoreline angle by back-projecting the slope of the abrasion platform to the paleocliff.')

%%
function pushbutton26_Callback(hObject, eventdata, handles)
msgbox('This routine is created to analyze rough coasts, calculating the maximum elevation of stacks. Modify the peak search parameter according to the DEM resolution (peak search ratio ~ DEM pixel size).')

%%
function pushbutton27_Callback(hObject, eventdata, handles)
msgbox('This routine calculates the geomorphic age of a terrace (Kt) and the shoreline angle.')

%%
function pushbutton29_Callback(hObject, eventdata, handles)
msgbox('Select the output format for shoreline angles')

%%
function pushbutton41_Callback(hObject, eventdata, handles)
msgbox('This routine uses a defined cliff slope.')

%%
function pushbutton35_Callback(hObject, eventdata, handles)
msgbox('Shoreline-angles and Kt values can be reviewed and edited using the table buttons')

%%
function pushbutton34_Callback(hObject, eventdata, handles)
msgbox('Post processing functions')

%%
function pushbutton33_Callback(hObject, eventdata, handles)
msgbox('Export your shoreline-angle results to PDF')

%% Command window Information display (static text)
function text38_CreateFcn(hObject, eventdata, handles)
handles = guidata(hObject);    
handles.text38=str2double(get(hObject,'String')); %returns contents of edit14 as a double
guidata(hObject, handles);

%% Directories interface 

%% TerraceM directory
function maindir_Callback(hObject, eventdata, handles)

handles = guidata(hObject);
dir1=char(uigetdir(pwd,'Set the path to Terracem script files'))
handles.maindir=char(dir1); %define handles for the path to terracem directory
set(handles.fullpath1,'String',dir1) %print terracem directory path in fullpath1 bar
% Update handles structure
guidata(hObject, handles);

%% Set station directory button
function stationsdir_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
dir2=char(uigetdir(pwd,'Set folder with stations files')) %navigate to stations folder
handles.stationsdir=char(dir2); %define handles for stations directory
set(handles.fullpath2,'String',dir2) %print stations directory in fullpath2 bar
% Save handles 
guidata(hObject, handles);

%% Set path 1
function path2dir1_Callback(hObject, eventdata, handles)

%% Set path 1
function path2dir1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Set path 2
function path2dir2_Callback(hObject, eventdata, handles)

%% Set path 2
function path2dir2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Main directory
function maindir_KeyPressFcn(hObject, eventdata, handles)

%% Display TerraceM directories in textbox
function fullpath1_Callback(hObject, eventdata, handles)
guidata(hObject, handles);

%% set TerraceM directories textbox properties
function fullpath1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Display station directory
function fullpath2_Callback(hObject, eventdata, handles)
guidata(hObject, handles);

%% Display stations directory
function fullpath2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% DEM display interface %%%%%%%%%%%%%%%%

%% DEM resolution textbox
function resoluti_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
handles.resoluti=str2double(get(hObject,'String')); %returns contents of edit14 as a double
guidata(hObject, handles);

%% DEM resolution textbox properties
function resoluti_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% DEM Shaded textbox
function azimuti_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
handles.azimuti=str2double(get(hObject,'String')); %returns contents of edit14 as a double
guidata(hObject, handles);

%% DEM shaded azimut textbox properties
function azimuti_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% plot options button group properties
function plot_options_CreateFcn(hObject, eventdata, handles)
handles = guidata(hObject);
handles.radio = hObject;
guidata(hObject, handles);

%% plot options button group interface
function plot_options_SelectionChangeFcn(hObject, eventdata, handles)
ax1=axis;
newButton=get(eventdata.NewValue,'tag');
maindir=handles.maindir;
stationsdir=handles.stationsdir;
station=handles.statsel;
UTM_zone=get(handles.utmzonen,'String');

if exist('handles.shpoint')==1
    D=handles.shpoint;
else
    D=[];
end

SF=handles.SF;
nim=numel(SF);
cd(char(maindir));
switch newButton
    
case 'radiobutton1'   
%set handles for image control in listbox2 
handles.demsel=0; %denote non dem activation
handles.shadsel=0; %GoogleMaps shaded desactivated
handles.imsel=0; %GoogleMaps image desactivated

%prompt imformation
Commands=('The display interface may be clean each time the display is changed (e.g. satellite, shaded or DEM)');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
cla

%plot profiles again
for tk=1:nim   
    obj.h=plot(SF(tk,1).Lon, SF(tk,1).Lat,'-k'); %plot shapefiles in 2D latlong system
    hold on
end
axis (ax1)
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
refreshdata(obj.h)

%plot shorelines again
if exist('handles.shpoint')==1
obj.p=plot(D(:,1),D(:,2),'o','MarkerEdgeColor','k','MarkerFaceColor','b');
end
axis (ax1)
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
axis equal
drawnow

case 'radiobutton2' %Load shaded relief GoogleMaps
%set handles for image control in listbox2 
handles.demsel=0; %denote non dem activation
handles.shadsel=1; %GoogleMaps shaded activated
handles.imsel=0; %GoogleMaps image desactivated
%set googlemaps style
param='&style=feature:landscape.natural.terrain&style=element:geometry.fill|color:0xffffff|saturation:-100|lightness:50|visibility:off|gamma:0.14';
%call plot googlemaps function
h1=plot_google_map('MapType','terrain','style',param);
%promt information on display
Commands=('GoogleMaps shaded relief image loaded');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);       
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
axis equal

case 'radiobutton3' %Load shaded rsatellite image GoogleMaps
%set handles for image control in listbox2 
handles.demsel=0; %denote non dem activation
handles.shadsel=0; %GoogleMaps shaded desactivated
handles.imsel=1; %GoogleMaps image activated    
%call plot googlemaps function
plot_google_map('MapType','satellite','style',0);
%promt message
Commands=('GoogleMaps satellite image loaded');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);       
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
axis equal

case 'radiobutton4' %load dem
%set handles for image control in listbox2 
handles.demsel=1; %dem display activation reflected in handles
handles.shadsel=0; %GoogleMaps shaded desactivated
handles.imsel=0; %GoogleMaps image desactivated
%change directory to DEM_XXX.mat location
cd(char(stationsdir)); 
cd(station)
%call to axis of main plot
axis (ax1)
% prompt information
Commands=('The DEM displays pixelated the first time is loaded, change the resolution and clean plot to adjust the display');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
%DEM loading procedure
%load &/or combine structures
DEMS=(sprintf('DEM_%s.mat',station));

if exist((DEMS),'file')==2    
load(DEMS)
X=DEMS.X;
Y=DEMS.Y;
Z=DEMS.Z;
xa=X'; 
xa(:,2)=Y(1,1);
ka=numel(xa(:,1));

    for f=1:ka; 
    xut(f,:)=(UTM_zone); %generate  UTM zone matrix
    end

ya=Y;
ya(:,2)=X(1,1); %generate sinthetic utm coordinates for LatLon transformation
ky=numel(ya(:,1));

    for k=1:ky; 
    yut(k,:)=(UTM_zone); %generate  UTM zone matrix
    end

% Convert bounding coordinates of raster area to LatLong
[xLa xLo]=utm2deg(xa(:,1),xa(:,2),xut);
[yLa yLo]=utm2deg(ya(:,2),ya(:,1),yut);

%plot using Beaducel (2014) DEM shading routine
Zf=flipud(DEMS.Z);
hold on
%manual inputs
N=handles.resoluti; %resampling 1/N
Az=handles.azimuti; %Azimut
[H I]=dem(xLo,yLa,Zf,'Azimuth',Az,'Contrast',0.5,'Lake',...
    'Decim',N,'Watermark',0,'LandColor',landcolor,'AxisEqual','off','NaNColor',[1 1 1],'ZCut',0);
%change directory to stationsdir
cd(char(stationsdir));

%plot profiles again
for tk=1:nim   
obj.h=plot(SF(tk,1).Lon, SF(tk,1).Lat,'-k'); %plot shapefiles in 2D latlong system
hold on
end

set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
refreshdata(obj.h)

%plot shorelines again
if exist('handles.shpoint')==1
obj.p=plot(D(:,1),D(:,2),'o','MarkerEdgeColor','k','MarkerFaceColor','b');%plot shorelines
refreshdata(obj.p)
end
refreshdata(H)
else    
msgbox('Error, please extract swath profiles again')
end    
end

guidata(hObject, handles);

%% Parameters for analysis functions

%% Difussion original slope textbox
function slope_Callback(hObject, eventdata, handles)

%% Difussion original slope textbox properties
function slope_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Diffusion parameters
function difu_Callback(hObject, eventdata, handles)

%% Diffusion parameters
function difu_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Diffussion start time
function t1_Callback(hObject, eventdata, handles)

%% Diffussion start time properties
function t1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Diffussion time interval
function ti_Callback(hObject, eventdata, handles)

%% Diffussion time interval properties
function ti_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Diffusion endtime
function t2_Callback(hObject, eventdata, handles)

%% Diffussion endtime properties
function t2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Stack analysis peak search ratio
function Search_ratio_Callback(hObject, eventdata, handles)

%% Stack analysis peak search ratio properties
function Search_ratio_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Free-face slope parameter
function edit14_Callback(hObject, eventdata, handles)
handles.edit14=str2double(get(hObject,'String')) %returns contents of edit14 as a double
guidata(hObject, handles);

%% Free-face slope properties
function edit14_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Free-face slope range 
function edit15_Callback(hObject, eventdata, handles)
handles.edit15=str2double(get(hObject,'String')); %returns contents of edit15 as a double
guidata(hObject, handles);

%% Free-face slope range properties
function edit15_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Directories management buttons %%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% Read directories button
function pushbutton5_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
%get handles
utmzone=get(handles.utmzonen,'String');
structdata = struct('terracem_dir', handles.maindir, 'stationsdir', handles.stationsdir,'zoneutm',utmzone); %define handles to save
addpath(handles.maindir) %set the main directory
save('terracem_path.mat', '-struct', 'structdata') %save path file as a structure

Commands=('Select the station to display the profiles');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

%only put folder names new version
d=dir((handles.stationsdir)); %set the station directory
isub = [d(:).isdir]; % returns logical vector
nameFolds = {d(isub).name}'; %obtain fold names
nameFolds(ismember(nameFolds,{'.','..'})) = []; 
set(handles.listbox_1,'string', nameFolds) % define listbox_1 elements (Stations)

%create shorelines output table if not exist
cd(handles.stationsdir) %before with handles.maindir
%load output table
file=('shorelines.txt');

if exist(file,'file')==0 
        fid = fopen(file, 'a');     
        fprintf(fid,'Station Profile_number shoreline_number east north distance_along_swath shoreline_elevation error analysis_type time');

fclose(fid);
type 'shorelines.txt' 
end

guidata(hObject, handles);

%% UTM zone textbox 
function utmzonen_Callback(hObject, eventdata, handles)
Commands=('Set the UTM zone of the dataset');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

guidata(hObject, handles);

%% UTM zone textbox properties
function utmzonen_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Set utm zone sub-GUI interface
function utmbutton_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
%call UTM GUI
zone=utmzone;

if numel(zone)==0    
    disp('load aborted') 
    Commands=('UTM not defined');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
else
%separate strings
if numel(zone)==3
    A=zone(1);
    B=zone(2);
    C=zone(3);
    utmzt=horzcat([A,B,' ',C]);
else
    A=zone(1);
    B=zone(2);  
    utmzt=horzcat(['0',A,' ',B]);
end
    set(handles.utmzonen,'String',utmzt)
end

guidata(hObject, handles);

%% select profile interface
%function profnum_Callback(hObject, eventdata, handles)

%% select profile properties
%function profnum_CreateFcn(hObject, eventdata, handles)
%if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%    set(hObject,'BackgroundColor','white');
%end

%% Select station listbox
function listbox_1_Callback(hObject, eventdata, handles)
Commands=('Select a station to display it contents. If profles are not displayed use the "Swath Profile Extraction"');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
handles = guidata(hObject);
handles.output = hObject;
%store the selected station name from listbox as station (input for
%terracem scripts)
contents = cellstr(get(hObject,'String')); %returns stationslist contents as cell array
station_selection=char(contents{get(hObject,'Value')}) %returns selected item from stationslist
handles.statsel=station_selection;
UTM_zone=get(handles.utmzonen,'String');
%put profile names of profiles in LISTBOX2%%%%%%%%%%
station=handles.statsel; %selected station
dirstations=handles.stationsdir; %stations directory 
try
cd(dirstations);
cd(station);
catch

Commands=('To run TerraceM set first the directories ');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
    
end

if exist(sprintf('%s_swaths.mat',station))~=0
g=load(sprintf('%s_swaths.mat',station)); % load swaths.mat dataset
as=g.nim;  %number of profiles per station
handles.nim=as; %add number of profiles to handles
af=(1:as);
a=num2cell(af); %transform number to cell
set(handles.listbox_2,'String',a); %set the string inputs for listbox 2
%load all boxes in black colour
file=sprintf('%s_clip.shp',station); %search for profiles in shapefile format
S3 = shaperead(file,'UseGeoCoords', true);
nim=numel(S3);

for i=1:nim %polygon entry
lon11=S3(i,1).Lon; %utm
lon11=lon11';
lat11=S3(i,1).Lat; %utm
lat11=lat11';
bb=S3(i,1).BoundingBox;%in utm
xy=[lon11 lat11];
xy(6,:)=[]; %remove redundant values of shp

for k=1:5; 
    utmzo2(k,:)=(UTM_zone); %zone
end
zone=utmzo2;
%utm2deg function
[LatF LonF]=utm2deg(xy(:,1),xy(:,2),zone);
%save as an structure
SF(i,1).Lon=LonF';
SF(i,1).Lat=LatF';
handles.SF=SF;
end

%plot rectangular profiles in 2D latlong system
for tk=1:nim   
obj.h=plot(SF(tk,1).Lon,SF(tk,1).Lat,'-k'); 
hold on
end

set(gca,'xtick',[])
set(gca,'ytick',[])
refreshdata(obj.h) %refresh data if plot changes
set(gca,'Position', [4 8.7 111 44]);
axis equal
%avoid listbox_2 disapearing when changing station
selection = get(handles.listbox_2, 'Value')
    if as < selection
    set(handles.listbox_2, 'Value', 1);
    end    
end
guidata(hObject, handles);

%% Select profile Listbox
function listbox_2_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
handles.output = hObject;
%store the selected profile name from listbox as station 
contents = cellstr(get(hObject,'String')); %returns profile contents as cell array
profile_selection=char(contents{get(hObject,'Value')}) %returns selected item from stationslist
handles.profsel=profile_selection;   
%plot selected profile in red colour
station=handles.statsel;
dirstations=handles.stationsdir;
%change to station directory

try
cd(dirstations);
cd(station);
catch
Commands=('In order to run TerraceM set first the directories');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
end

file=sprintf('%s_clip.shp',station); 
try
S3 = shaperead(file,'UseGeoCoords', true);
nim=handles.nim;
UTM_zone=get(handles.utmzonen,'String');

for i=1:nim %polygon entry
lon11=S3(i,1).Lon; %
lon11=lon11';
lat11=S3(i,1).Lat; %
lat11=lat11';
bb=S3(i,1).BoundingBox;%in utm
xy=[lon11 lat11];
xy(6,:)=[]; %remove redundant values of shp
%set UTM zone matrix
for k=1:5; 
    utmzo2(k,:)=(UTM_zone); %zone
end

%Convert everything to LatLong for plotting
zone=utmzo2;
[LatF LonF]=utm2deg(xy(:,1),xy(:,2),zone);
SF(i,1).Lon=LonF';
SF(i,1).Lat=LatF';
end

%manage profiles
for i=1:nim
    [SF(i,1).Id]=i; %assign an id    
if str2double(profile_selection) == SF(i,1).Id;
 handles.a=([SF(i,1).Lon]'); %selected swath x
 handles.b=([SF(i,1).Lat]'); %selected swath y
       
end
end

% Plot DEM if dem plot is selected
ax1=axis;
if (handles.demsel)==1 %check if dem was activated from menu
%call to axis of main plot
axis (ax1)
% prompt information
Commands=('DEM display');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
%DEM loading procedure
%load &/or combine structures
DEMS=(sprintf('DEM_%s.mat',station));
if exist((DEMS),'file')==2  
load(DEMS)
X=DEMS.X;
Y=DEMS.Y;
Z=DEMS.Z;
xa=X'; 
xa(:,2)=Y(1,1);
ka=numel(xa(:,1));
    for f=1:ka; 
    xut(f,:)=(UTM_zone); %generate  UTM zone matrix
    end
ya=Y;
ya(:,2)=X(1,1); %generate sinthetic utm coordinates for LatLon transsformation
ky=numel(ya(:,1)); 
    for k=1:ky; 
    yut(k,:)=(UTM_zone); %generate  UTM zone matrix
    end
% Tranform UTM to LatLon
[xLa xLo]=utm2deg(xa(:,1),xa(:,2),xut);
[yLa yLo]=utm2deg(ya(:,2),ya(:,1),yut);
%plot using Beaducel (2014) DEM shading routine
Zf=flipud(DEMS.Z);
hold on
%user defined inputs
N=handles.resoluti; %resampling 1/N
Az=handles.azimuti; %Azimut
[H I]=dem(xLo,yLa,Zf,'Azimuth',Az,'Contrast',0.5,'Lake',...
    'Decim',N,'Watermark',0,'LandColor',landcolor,'AxisEqual','off','NaNColor',[1 1 1],'ZCut',0);
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
refreshdata(H)
%prompt message
Commands=('To switch between different displays Clean the display interface (Diplays: DEM, satellite, and shaded )');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
else    
%prompt message
Commands=('Error!! check the existence of XXX_DEM.mat in your stations folder path, otherwise run "Extract Swath profiles" again');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
end
end

% if plot shaded selected
if (handles.shadsel)==1 %check if shaded googlemaps was activated from menu
%set googlemaps style
param='&style=feature:landscape.natural.terrain&style=element:geometry.fill|color:0xffffff|saturation:-100|lightness:50|visibility:off|gamma:0.14';
%call plot googlemaps function
h1=plot_google_map('MapType','terrain','style',param);
%axis(ax1)         
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);    
%prompt message
Commands=('To switch between different displays "Clean" the display interface (Diplays: DEM, satellite, and shaded )');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);    
end

% if satellite image is selected
if (handles.imsel)==1 %check if shaded googlemaps was activated from menu
%call plot googlemaps function
plot_google_map('MapType','satellite','style',0);        
set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
axis equal      
%prompt message
Commands=('To switch between different displays Clean the display interface (Diplays: DEM, Satellite, and Shaded )');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);        
end

% plot profiles in all cases
for tk=1:nim   
obj.h=plot(SF(tk,1).Lon,SF(tk,1).Lat,'-k','LineWidth',1); %plot shapefiles in 2D latlong system
hold on
end

set(gca,'xtick',[])
set(gca,'ytick',[])
set(gca,'Position', [4 8.7 111 44]);
%plot selected profile in red
obj.i=plot(handles.a,handles.b,'-r','LineWidth',1); %'LineWidth',2
handles.objh=(obj.h);
handles.obji=(obj.i);
set(gca,'xtick',[])
set(gca,'ytick',[])
%prompt message
Commands=('To visualize a selected porfile use the "Profile plotter" button. The analysis functions allows analyzing the selected profile and estimate the shoreline angle');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

% load shorelines table
if true
cd(dirstations);
file=('shorelines.txt');
fid=fopen(file,'r');
i=1;
while ~feof(fid)
A=textscan(fid,'%s %u %u %f %f %f %f %f %s %f/','delimiter',' ','HeaderLines',1);    
   for j=1:10 %number of columns (default)
       data(i,j) = A(1,j);
   end
i=i+1;
end
fclose(fid);
clear j i 
shore_pts(:,1)=cell2mat(data(:,4));
shore_pts(:,2)=cell2mat(data(:,5));
%convert shorelines to latlong
nix=numel(shore_pts(:,1));

if nix>0
for k=1:nix; 
    utmzo(k,:)=(UTM_zone); %zone
end

zone=utmzo;
[LatFp LonFp]=utm2deg(shore_pts(:,1),shore_pts(:,2),zone);
SP(:,1)=LonFp;
SP(:,2)=LatFp;
handles.shpoint=SP;
obj.p=plot(LonFp(:,1),LatFp(:,1),'o','MarkerEdgeColor','k','MarkerFaceColor','b');
axis (ax1)
hold off
set(gca,'xtick',[])
set(gca,'ytick',[])
end
end
%save data
guidata(hObject, handles);
catch
    Commands=('To run TerraceM set first the directories ');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
end

%% Select profile listbox properties
function listbox_2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% Select stations listbox properties
function listbox_1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%% PROCESSING AND ANALYSIS FUNCTIONS %%

%% Extract swaths 
% Confirm swath extraction checkbox
function sureornot_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
    Commands=('Prepare to extract swath profiles. This function also to update modifications of swath profile shapefiles');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);

sure=get(hObject,'Value');
handles.sureornot=sure;
%save data to handles
guidata(hObject, handles);

%% Swath profile extraction button
function swatbuton_Callback(hObject, eventdata, handles)
handles = guidata(hObject);

if handles.sureornot==1  
%read inputs
path = 'terracem_path.mat';

if exist(path,'file')
     load(path);
else msgbox('Problem with path, enter again the input paths')
end

% select station 
station=handles.statsel
dirstations=handles.stationsdir;
Commands=('Please wait, processing data');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
cd(dirstations);
cd(station);
% load asciigrid or geotiff
asc_file=sprintf('%s_dem.asc',station); 
tiff_file=sprintf('%s_dem.tif',station);
cdx=pwd;

if exist(fullfile(cdx,asc_file),'file') == 2; %if ascii exist load it
    [Z,R] = arcgridread(asc_file);
    Z2=flipud(Z);
    dd=R(2,1); [ny nx]=size(Z);
    x1=R(3,1); x2=R(3,1)+dd*(nx-1);
    y2=R(3,2); y1=R(3,2)-dd*(ny-1);
    [X,Y]=meshgrid(x1:dd:x2,y1:dd:y2);
    X2=X;
    Y2=Y;
    X=X(1,:);
    Y=Y(:,1);
else %search for geotiff if ascii dont exist
[Z,R] = geotiffread(tiff_file);
Z = double(Z);
Z=flipud(Z);
Z(Z == -9999) = NaN; %outliers
Z(Z == -32767) = NaN;
Z2=Z;
dd=R.DeltaX; 
[ny nx]=size(Z);
x1=R.XLimWorld(1,1); 
x2=R.XLimWorld(1,1)+dd*(nx-1);
y2=R.YLimWorld(1,2); 
y1=R.YLimWorld(1,2)-dd*(ny-1);        
[X,Y]=meshgrid(x1:dd:x2,y1:dd:y2);  
X2=X;
Y2=Y;
X=X(1,:);
Y=Y(:,1);
end    

%save formated dem
DEMS=(sprintf('DEM_%s.mat',station));

%load table &/or combine structures
if exist(fullfile(DEMS,pwd),'file')==2    
load(DEMS)
DEMS.X=X;
DEMS.Y=Y;
DEMS.Z=Z;
save((sprintf('DEM_%s.mat',station)),'DEMS'); 
%in case dont exist, create file
else
clear DEMS
DEMS.X=X;
DEMS.Y=Y;
DEMS.Z=Z;
save((sprintf('DEM_%s.mat',station)),'DEMS');

end

file=sprintf('%s_clip.shp',station); %load the .shp rectangular profile areas
p=shaperead(file); 
nim=numel(p);
% Clip topography data with polygons
% Extract corners for each rectangular profile and clip with topography

Q = waitbar(0.1,'Please wait... procesing the swath data','windowstyle', 'modal');
frames = java.awt.Frame.getFrames();
frames(end).setAlwaysOnTop(1); 
for i=1:nim    
    data=[];
    waitbar(i / nim);
   
    data=p(i,1);     
    x=data.X;       %extract x values from shapefile
    x=(x');         %transpose elements
    x(end)=[];
    y=data.Y;       %extract y values from shapefile
    y=(y');         %transpose elements
    y(end)=[]; 
    xy=[x y];       %conform the resulting matrix
    xy(end,:)=[];   %delete the redundant last row and fix a 4 vertices polygon    
    taga=num2str(i); %assign names and vertice coordinates for each polygon
    v = genvarname(['Prof' taga]);
    eval([v '=xy;']);   
    in = inpolygon(X2,Y2,xy(:,1),xy(:,2)); %clip only X Y data of topography        
      
    %create cropped xyz for rotation input
    xyz(:,1)=X2(in);
    xyz(:,2)=Y2(in);
    xyz(:,3)=Z2(in);    
    %call function to extract swaths
    [swat,pto,thetaB,Dprof,ZI]=Terracem_extract_swaths(xy,xyz,station,i);    
    clear xyz xy in
    taga=num2str(i);
    v = genvarname(['swat' taga]); %Asign names for each cliped area
    eval([v '=swat;']); %Asign xyz values for each cliped area
    v = genvarname(['thetaB' taga]); %angle longest side
    eval([v '=thetaB;']); %angle of longest side
    v = genvarname(['pto' taga]); %point
    eval([v '=pto;']); %Asign minor xy point values for each cliped area
    v = genvarname(['Dprof' taga]); %point
    eval([v '=Dprof;']); %Asign minor xy point values for each cliped area    
    v = genvarname(['ZI' taga]); % mesh swath
    eval([v '=ZI;']); %  
    fprintf('...Extracting profile %u / %u...\n',i,nim)
end
close(Q);
clear DEMS frames data X2 Y2 Xp Xt Yp Yt h lati loni xy x y taga a out ex i swat Q R X Y Z Zc dd file nx ny v x1 x2 y1 y2 Commands T Tcell asc_file
clear cdx dirstations eventdata path p stationsdir terracem_dir tiff_file zoneutm pto thetaB Dprof ZI
%clearvars -except swat thetaB pto Dprof

% Save workspace for shoreline fit routine
save(sprintf('%s_swaths.mat',station),'-regexp','^(?!(hObject|handles|station|profsel)$).');

end

if handles.svpdf==1; %check if save swath to PDF is required
SWW=load(sprintf ('%s_swaths.mat',station)); 
%nim=numel(p)
%nim2=numel(SWW)
ps=3;% plots per page 
pg=ceil(nim/ps);%number of pages

%load swaths
for i=1:nim    
    SW=SWW.(sprintf('swat%u',i));    
    Xll=SW(:,1);%x
    Yll=SW(:,4);%max topography
    Yl2=SW(:,2);%minimum
    Yl3=SW(:,3);%mean    
    %loop subplot
    xt(i)=rem(i-1,ps)+1;    
    %generate new figure page after 3 plots  
    
    if xt(i)==1
    figure;
    end    
    ax1(i)=subplot(3,1,xt(i)); %loop subplot size 
    hold on
    plot(Xll,Yll,'-k');
    plot(Xll,Yl2,'-k');
    text(min(Xll)+200,max(Yll)-((max(Yll)-min(Yll))/4),num2str(i-1),'FontSize',18);
    plot(Xll,Yl3,'-b','linewidth',0.7); 
    xlim([min(Xll) max(Xll)]);   
    xlabel('Distance along profile (m)');
    ylabel('Elevation (m)');
    
    %set page dimensions
    if xt(i)==ps || i==nim
    rect=[1 0 19 29];
    set(gcf,'paperunits','centimeters');
    set(gcf,'papertype','A4');    
    set(gcf,'paperposition',rect);    
    fout = sprintf('Swaths_%s_page_%u',station,ceil(i/ps));
    saveas(gcf,fout,'pdf');
    end     
end     
end    
guidata(hObject, handles);

%% Save swaths as pdf checkbox
function svpdf_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
%promt information
    Commands=('Swath profiles will be saved in .pdf format');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
vaono=get(hObject,'Value');
handles.svpdf=vaono;
%save data to handles
guidata(hObject, handles);


%% CLASSIC TERRACE ANALYSIS
function pushbutton8_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
%promt information
    Commands=('The user should indicate the terrace level to map');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',T);
    
    
    
station=handles.statsel; %selected station
dirstations=handles.stationsdir; %path to stations
cd(dirstations);
cd(station);


g=load(sprintf('%s_swaths.mat',station)); %load swaths.mat database
count=0; %number of shorelines 
profnum=str2double(handles.profsel); %selected profile
nim=handles.nim; %nim is the number of profiles for each station



%while nim>0	   
    batchmode=handles.batchmode;
    
    if batchmode==1
    %Graphic interface for shoreline level in batch mode analysis
    shorenum = str2double(inputdlg('Enter shoreline level for batch mode mapping. [0=exit]'));   
    
    for profnum=1:nim        
    swat=g.(sprintf('swat%u',profnum));
    thetaB=g.(sprintf('thetaB%u',profnum)); 
    pto=g.(sprintf('pto%u',profnum));  
    Dprof=g.(sprintf('Dprof%u',profnum)); 
    %promt information
    Commands=('Staricase analysis in batch mode allows performing a continuous analysis of swath profiles');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',T);
    %change directories
    cd(dirstations);
    cd(station);
    
    
    
    %call to function Sfitprof  
    shoreline=Terracem_sfitprof(swat,station,profnum,shorenum,pto,thetaB,Dprof,batchmode); 
    handles.t=now;
    %change directory    
    cd(dirstations); 
    %Read data file 
    file=('shorelines.txt');
    %write header if file not exist
    fid = fopen(file, 'a');    
    fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f staircase %8.5f',station,profnum,shoreline,now);
    fclose(fid);
    type 'shorelines.txt' 
    %promt information   
    Commands=('The shoreline angle has been saved');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);     
    count=count+1;
    profnum=profnum+1;   
    end    
    else    
    %Graphic interface for shoreline level
    shorenum = str2double(inputdlg(sprintf('CONTINUE..? [0=exit]. Enter shoreline level (profile %u has %u shorelines) ',profnum,count)));   
    if shorenum== 0
        return          
    else    
    % select inputs
    swat=g.(sprintf('swat%u',profnum));
    thetaB=g.(sprintf('thetaB%u',profnum)); 
    pto=g.(sprintf('pto%u',profnum));  
    Dprof=g.(sprintf('Dprof%u',profnum));         
    cd(dirstations);
    cd(station);
    
  %promt message
    Commands=('Staricase analysis: 4 points are used to determine the shoreline angle from right-to-left. (1-2) Along the palecliff zone 2 points should be marked with red crosshair; and (3-4) along the paleo platform two points with blue crosshair.');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',T);
    
    %call to the function Sfitprof %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%   
    shoreline=Terracem_sfitprof(swat,station,profnum,shorenum,pto,thetaB,Dprof,batchmode); 
    handles.t=now;
    pause(2)    
    cd(dirstations); %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %Read data file 
    file=('shorelines.txt');
        fid = fopen(file, 'a');    
        fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f staircase %8.5f',station,profnum,shoreline,now);    
    fclose(fid);
    type 'shorelines.txt' 
    disp('Shoreline Saved')
    %promt information
    Commands=('The shoreline has been saved');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    count=count+1;
    end
    end
%end

%% Batchmode checkbox for staircase analysis
function batchmode_Callback(hObject, eventdata, handles)
%promt information    
    Commands=('Staricase analysis in batch mode allows performing a continuous analysis of swath profiles');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);

batchmode=get(hObject,'Value')
handles.batchmode=batchmode;
%save data to handles
guidata(hObject, handles);

%% Cliff Free-face analysis call button
function fxcliff_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
station=handles.statsel; %selected station
dirstations=handles.stationsdir; %path to stations
cd(dirstations);
cd(station);
g=load(sprintf('%s_swaths.mat',station)); %load swaths.mat database
count=0; %number of shorelines 
profnum=str2double(handles.profsel); %selected profile
%promt information
    Commands=('The user should indicate the terrace level to map');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);    
nim=handles.nim; %nim is the number of profiles for each station

%while nim>0	    
    shorenum = str2double(inputdlg(sprintf('[0=exit]. Enter shoreline number (profile %u has %u shorelines) ',profnum,count)));    
    if shorenum== 0
        return          
    else          
    swat=g.(sprintf('swat%u',profnum));
    thetaB=g.(sprintf('thetaB%u',profnum)); 
    pto=g.(sprintf('pto%u',profnum));  
    Dprof=g.(sprintf('Dprof%u',profnum));  
    slo=handles.edit15;
    ra=handles.edit14;   
    cd(dirstations);
    cd(station);
    %promt information
    Commands=('Cliff Free Face: Extrapolations of a custom cliff-slope and paleo-platform are intersected by defining 3 points form right-to-left: (1) The coluvium-bedrock contact at the cliff with red crosshair (2) Two points defining the paleo platform with blue corsshair');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',T);     
    %call to function Sfitprof %%  
    shoreline=Terracem_fxcliff(swat,station,profnum,shorenum,pto,thetaB,Dprof,slo,ra); 
    handles.t=now;
    cd(dirstations); 
    %Read data file 
    file=('shorelines.txt');
    %write header if file not exist
    fid = fopen(file, 'a');    
    fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f fix %8.5f',station,profnum,shoreline,now);
    fclose(fid);
    type 'shorelines.txt' 
    %disp('Shoreline Saved')
    Commands=('The shoreline have been saved, congratulations ^_^');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);    
    count=count+1;       
    end
%end

%% Stack analysis call button
function pushbutton9_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
station=handles.statsel; %selected station
dirstations=handles.stationsdir; %path to stations
cd(dirstations);
cd(station);
g=load(sprintf('%s_swaths.mat',station)); %load swaths.mat database
count=0; %number of shorelines 
profnum=str2double(handles.profsel); %selected profile
nim=handles.nim; %nim is the number of profiles for each station

Commands=('Detection of sea-stacks and extrapolation towards the cliff. (1) The stacks zone is defined by two points from right-to-left with blue crosshair. (2) Levels or fringes from bottom-to-top with the green crosshair. (3) Slope inflection at the cliff (black corsshair)');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);  

while profnum>0   
while nim>0   
% select inputs
    swat=g.(sprintf('swat%u',profnum));
    thetaB=g.(sprintf('thetaB%u',profnum)); 
    pto=g.(sprintf('pto%u',profnum));  
    Dprof=g.(sprintf('Dprof%u',profnum));          
    cd(dirstations);
    cd(station);  
% call to the function Stacks Analysis
    peak=str2num(get(handles.Search_ratio,'String')); %peak search ratio input    
    [stacks]=Terracem_stacks(swat,station,profnum,pto,thetaB,Dprof,peak);
handles.t=now;      
cd(dirstations); 


%Read shorelines data file 
    file=('shorelines.txt'); 
    
    if exist (file,'file')==0
    sfprint('Error, the shoreline file has been deleted by error, please load the directories again')    
    else        
    numb=numel(stacks(:,1)); 
    
    for i=1:numb;    
    fid = fopen(file, 'a');    
    fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f stack %8.5f',station,profnum,stacks(i,:),now);
    end   
    fclose(fid);
    end
    
    type 'shorelines.txt' 
    disp('Shoreline Saved')
    %promt information
    Commands=('The shoreline have been saved :p');   
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    count=count+1;  
%save secondary outputs table for each station (check vertcat)  
     cd(station)    
     file2=sprintf ('%s_stackpeaks.mat',station);
     return     
end
end            
guidata(hObject, handles);

%% Difussion analysis call button
function difusionbuton_Callback(hObject, eventdata, handles)
handles = guidata(hObject);
station=handles.statsel;
dirstations=handles.stationsdir;
cd(dirstations)
cd(station)
g=load(sprintf('%s_swaths.mat',station));
count=0; %number of shorelines 
profnum=str2double(handles.profsel);
nim=handles.nim;
Commands=('The user should indicate the terrace level to map');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);  
  

%while profnum>0    
%while nim>0	  
    %Graphic interface
    shorenum = str2double(inputdlg(sprintf('Enter shoreline level (profile %u has %u shorelines)',profnum,count)));
    
    
    
    
    if shorenum==0
          return         
    else   
    % select inputs
    swat=g.(sprintf('swat%u',profnum));
    thetaB=g.(sprintf('thetaB%u',profnum)); 
    pto=g.(sprintf('pto%u',profnum));  
    Dprof=g.(sprintf('Dprof%u',profnum));      
    %diffusion parameters
    thetadegrees=str2num(get(handles.slope,'String'));
    k=str2num(get(handles.difu,'String'));
    t1=str2num(get(handles.t1,'String'));
    ti=str2num(get(handles.ti,'String'));
    t2=str2num(get(handles.t2,'String'));
    %change directory
    cd(dirstations);
    cd(station);
    %promt information
    Commands=('The analysis area should be set adjusting the zoom. (1) One point is defined at the top of paleo-cliff, (2) The paleo-platform is defined by two points from right-to left, (3) finally one point defines the center of profile, near the dashed line.');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',T);    
    %call fit function
    [shoreline Difusion]=Terracem_terracediff(swat,station,profnum,shorenum,pto,thetaB,Dprof,thetadegrees,k,t1,ti,t2);
    handles.t=now;    
    cd(dirstations);
    %Read outputs table file 
    file=('shorelines.txt');
    fid = fopen(file, 'a');    
    fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f diffusion %8.5f',station,profnum,shoreline,now);    
    fclose(fid);
    type 'shorelines.txt' 
    disp('Shoreline Saved')
    %promt information
    Commands=('The shoreline have been saved');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);   
    count=count+1;
    
    %save secondary outputs table   
    cd(station)    
    file2=sprintf ('%s_diffusion.mat',station);
   
    if exist(file2,'file')==0 
    DIFFUSION=Difusion;     
    save(file2,'DIFFUSION')
    else
    load(file2);        
    DIFFUSION=vertcat(DIFFUSION,Difusion); 
    save(file2,'DIFFUSION');
    end      
   end
%end
%end
guidata(hObject, handles);
    



%% Post-processing/export buttons 
%% table edition interface
function table_edition_Callback(hObject, eventdata, handles)

dirstations=handles.stationsdir; %path to stations
cd(dirstations);

Commands=('This table contains the shoreline angle outputs. The input file of the table -shorelines.txt- is stored in the stations folder');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

handles = guidata(hObject);
%call table editing function
cnames = {'Station', 'Profile_number', 'shoreline_number', 'east', 'north', 'distance_along_swath', 'shoreline_elevation', 'error', 'analysis_type', 'time'};%column names
try
myTable('shorelines.txt',cnames)
catch
msgbox('No shorelines')    
end    
%% open diffusion results table
function tablekt_Callback(hObject, eventdata, handles)
% hObject    handle to tablekt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
dirstations=handles.stationsdir; %path to stations
cd(dirstations);

Commands=('This table contains the shoreline angles and diffusion analysis outputs. The input file for this table -diffusion.txt- is stored in the station folder');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

station=handles.statsel;
cd(station)
try
load(sprintf('%s_diffusion.mat',station))

% set variables 
profnum=DIFFUSION(:,1);
shorenum=DIFFUSION(:,2);
x=DIFFUSION(:,3);
y=DIFFUSION(:,4);
z=DIFFUSION(:,5);
ze=DIFFUSION(:,6);
kt=DIFFUSION(:,7);
rms=DIFFUSION(:,8);
a=DIFFUSION(:,9);
b=DIFFUSION(:,10);

%Read data file  
if exist('difussion.txt','file') ==2
%delete file difussion.txt
delete('difussion.txt')
    
file1=('difussion.txt');   
for i=1:numel(DIFFUSION(:,1))
    
    titles={'station', 'profile', 'shoreline', 'X','Y','Elevation (Z)','Ze','Kt','RMS','a'};
    
        fid = fopen(file1, 'a');    
        fprintf(fid,'\n%s %u %u %6.0f %7.0f %4.2f %4.2f %4.2f %4.2f %4.2f,%4.2f',station,DIFFUSION(i,:)');
end    
    fclose(fid);
    type 'difussion.txt' 
    disp('Difussion data Saved')
    
    Commands=('Difussion data Saved');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    %save table
    myTable('difussion.txt',titles)
else

file1=('difussion.txt');   
for i=1:numel(DIFFUSION(:,1))
        fid = fopen(file1, 'a');    
        fprintf(fid,'\n%s %u %u %6.0f %7.0f %4.2f %4.2f %4.2f %4.2f %4.2f,%4.2f',station,DIFFUSION(i,:)');
end    
    fclose(fid);
    type 'difussion.txt' 
    disp('Difussion data Saved')
    
    Commands=('Difussion data Saved');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    
    
myTable('difussion.txt')
end
catch

msgbox('No scarp difussion have been calculated yet')
end    
%% Cretae data repository  in PDF
function pushbutton32_Callback(hObject, eventdata, handles)

%set directories
station=handles.statsel;
dirstations=handles.stationsdir;
cd(dirstations)
cd(station)

Commands=('The output plots of shoreline angle fits may be exported to .pdf files');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

try
%load .mat container of figures
load(sprintf ('%s_fits.mat',station)); 
fields = (fieldnames(Fits)); %names of figures
nim=numel(fields); %numel figures in directory
catch
    msgbox('No shorelines')
end

ps=8;% plots per page
pg=ceil(nim/ps);%number of pages

%decompose names using textscan & detect profnum and shorenum values
for i=1:nim
    str=fields{i,1};
    all(i,:)=textscan(str,'%s','delimiter','_');
    profnum=str2double(all{i,1}{2,1}); %identifier of profile
    shorenum=str2double(all{i,1}{3,1}); %identifier of shoreline
  
    %define structures for each figure based on shorenum and profnum
    myFigstruct=Fits.(sprintf('%s_%u_%u_fit',station,profnum,shorenum));
try
    Xll(i,:)=myFigstruct.children(1,1).properties.XLim; %xlim from structure
    Yll(i,:)=myFigstruct.children(1,1).properties.YLim; %ylim from structure
catch
msgbox('mark the last unloaded fit of the DR again')    
end
    %loop subplot
    xt(i)=rem(i-1,ps)+1;
    
    %generate new figure page after 8 plots  
    if xt(i)==1
    figure;
    end
        
    ax1(i)=subplot(4,2,xt(i)); %loop subplot size   
    xlim(myFigstruct.children(1,1).properties.XLim)
    ylim(myFigstruct.children(1,1).properties.YLim)
    xlabel('Distance (m)'); ylabel('Elevation (m)')
    
    %copy fig handles to multiplot
    h1(i) = struct2handle(myFigstruct,0);       
    copyobj(allchild(get(h1(i),'CurrentAxes')),ax1(i)); 
    
    xlabel('Distance along profile (m)')
    ylabel('Elevation (m)')
    close(h1(i))
    
    %set page dimensions
    if xt(i)==ps || i==nim
    rect=[1 0 19 29];
    set(gcf,'paperunits','centimeters');
    set(gcf,'papertype','A4');    
    set(gcf,'paperposition',rect);    
    fout = sprintf('Data-Repository_%s_%u',station,ceil(i/ps));
    saveas(gcf,fout,'pdf');
    end    
end
clear xt it ps np pg fout 

%% generate histograms (shoreline statistics)
function shore_statistic_Callback(hObject, eventdata, handles)
guidata(hObject, handles);

Commands=('The Statistics routine create histograms of shoreline-angle elevations for each station of the project, the figure is stored as a .pdf file in the station folder');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);

%path to stations
dirstations=handles.stationsdir; 
cd(dirstations);

%load table
file=('shorelines.txt');
if exist(file,'file')==1 || exist(file,'file')==2
    
%load shorelines table
fid=fopen(file,'r');
i=1;
while ~feof(fid)
    A=textscan(fid,'%s %u %u %f %f %f %f %f %s %f/','delimiter',' ','HeaderLines',1);
    
    for j=1:10 %number of columns (default of shorelines.txt)
        data(i,j) = A(1,j);
    end
    i=i+1;
end
fclose(fid);
%extract data from table
nim=numel(data(:,10)); u=1;

for k=1:nim
md1(u,1)=data{k,4}; %x
md1(u,2)=data{k,5}; %Y
md1(u,3)=data{k,7}; %z
md1(u,4)=data{k,8}; %ze
md1(u,5)=data{k,3}; %shore
%md1(u,6)=data{k,2}; %profnum
vars{u,1}=data{k,1}{1,1}; %station names

u=1+u;
end
end


name=(vars);
%shorelines clasification of names
name2=cellfun(@double,name,'uniformoutput',0);
code_shore=cell2mat(name2);
tab(:,1)=code_shore(:,1); %code_name  station
tab(:,2)=code_shore(:,2); %code_name  station
tab(:,3)=code_shore(:,3); %code_name  station
tab(:,4)=code_shore(:,4); %code_name  station
tab(:,5)=md1(:,3); %shoreline elevation
tab(:,6)=md1(:,4); %shoreline error
tab(:,7)=md1(:,5); %terrace shore
% loop to obtain all codes of avaliable stations
C = unique(tab(:,1:4),'rows');
numc=numel(C(:,1)); %number of name inputs & plots
for w=1:numc
%figure(w)  
r=1;
    for Q=1:nim %total elements in table   
    
    if tab(Q,(1:4)) == C(w,(1:4))
       vars2=(vars(Q,:));

       h_sh(r,:)=(tab(Q,5));       
       nx=numel(h_sh);      
       ppp(w).sh(r,:)=(tab(Q,5));
       ppp(w).st(r,:)=(vars2{1,1});
       r=r+1;    
    end
    end
end
cd(handles.maindir);
ps=6;% plots per page (par number)
np=numc; %total number of plots

for it=1:np
    xt=rem(it-1,ps)+1;
    if xt==1
    figure;
    end
    %subplots
    ax1=subplot(ps/2,2,xt);
    hold on
    hist(ppp(it).sh,sqrt(numel(ppp(it).sh)))
    hold on
    na=(ppp(it).st(1,:));
    %histogram statistics
    vline(mean(ppp(it).sh),'r')
    vline(mean(ppp(it).sh)-(std(ppp(it).sh)/2),'r--')
    vline(mean(ppp(it).sh)+(std(ppp(it).sh)/2),'r--')    
    texto1=num2str(mean(ppp(it).sh));
    text(mean(ppp(it).sh+0.5),30,texto1)
    xlabel('Elevation (m)')
    ylabel('Number of shorelines')
    title(sprintf('Shoreline statistics of station %s',na));  
    cd(dirstations);    
    %save to pdf routine
    if xt(it)==ps || it==np
    rect=[1 0 19 29];
    set(gcf,'paperunits','centimeters');
    set(gcf,'papertype','A4');    
    set(gcf,'paperposition',rect);     
    fout = sprintf('Station-statistics_%u',ceil(it/ps));
    saveas(gcf,fout,'pdf');
    end 
end

%% export in shapefile format
function shapexport_Callback(hObject, eventdata, handles)
%set directories
dirstations=handles.stationsdir; %path to stations
cd(dirstations);
Commands=('Shoreline angle outputs may be exported to ESRI shapefile format.');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
%read table
file=('shorelines.txt');
fid=fopen(file,'r');
data=textscan(fid,'%4s %f %f %f %f %f %f %f %s %f','HeaderLines',1);
fclose(fid);
% Cell2Mat
id(:,1)=data{1,1}(:,1);
pnum(:,1)=data{1,2}(:,1);
snum(:,1)=data{1,3}(:,1);
j=1;

for i=4:8
    xydze(:,j)=data{1,i}(:,1); 
    j=j+1;
end

ana(:,1)=data{1,9}(:,1); 
%Export shape
[Tracks(1:length(xydze(:,1))).Geometry] = deal('Point');
%utmzonen='18 H';
utmzone=get(handles.utmzonen,'String');

for i = 1:length(xydze(:,1))
    [Tracks(i).station]= id{i,1};
    [Tracks(i).profile]= pnum(i,1);
    [Tracks(i).shoreline]= snum(i,1);
    [Tracks(i).X]= xydze(i,1);
    [Tracks(i).Y]= xydze(i,2);
    [Tracks(i).distance]= xydze(i,3);
    [Tracks(i).Z]= xydze(i,4);
    [Tracks(i).Ze]= xydze(i,5);        
    [Tracks(i).type] = ana{i,1};  
    [Lat,Lon] = utm2deg(xydze(i,1),xydze(i,2),utmzone);   
end

%outputs
fout=('shorelines_points.shp');
try
shapewrite(Tracks, fout);
catch
msgbox('No shorelines')
end

%% export in google earth format
function exportkmz_Callback(hObject, eventdata, handles)
%set directories
dirstations=handles.stationsdir; %path to stations
cd(dirstations);
%promt information
Commands=('Shoreline angle outputs may be exported to GooGle Earth (.kml) format.');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
%load table
file=('shorelines.txt');
fid=fopen(file,'r');
data=textscan(fid,'%4s %f %f %f %f %f %f %f %s %f','HeaderLines',1);
fclose(fid);
% Cell2Mat
id(:,1)=data{1,1}(:,1);
pnum(:,1)=data{1,2}(:,1);
snum(:,1)=data{1,3}(:,1);
j=1;

for i=4:8
    xydze(:,j)=data{1,i}(:,1); 
    j=j+1;
end

ana(:,1)=data{1,9}(:,1); %analysis method
time(:,1)=data{1,10}(:,1); %time of execution
%Export kml
[Tracks(1:length(xydze(:,1))).Geometry] = deal('Point');
utmzone=get(handles.utmzonen,'String');

for i = 1:length(xydze(:,1))
    [Lat,Lon] = utm2deg(xydze(i,1),xydze(i,2),utmzone);
    [Tracks(i).Lat]= Lat;
    [Tracks(i).Lon]= Lon;
    [Tracks(i).station]= id{i,1};
    [Tracks(i).profile]= pnum(i,1);
    [Tracks(i).shoreline]= snum(i,1);
    [Tracks(i).X]= xydze(i,1);
    [Tracks(i).Y]= xydze(i,2);
    [Tracks(i).distance]= xydze(i,3);
    [Tracks(i).Z]= xydze(i,4);
    [Tracks(i).Ze]= xydze(i,5);        
    [Tracks(i).type] = ana{i,1};  
end

fout=(sprintf('shorelines.kml'));
try
kmlwrite(fout, Tracks, 'Name', id);
catch
    msgbox('No shorelines')
end

%% Sub-GUI button calls %%%%%%%%%%%%%%

%% Swath profile display sub-GUI properties
function profile_Callback(hObject, eventdata, handles)

%% Swath profile display sub-GUI call button
function profile_button_Callback(hObject, eventdata, handles)
maindir=handles.maindir;
cd(maindir)
dirstations=handles.stationsdir;
station=handles.statsel;
profsel=handles.profsel; 
save('terracem_path.mat','station','profsel','-append')
Commands=('Swath previewer display swath profiles and shoreline angle fits. Swath profiles can be displayed as lineas, grey patch, or color-coded by stacked probability distribution functions. Shorelines-angles, if already calculated, can be displayed');
T = evalc('Commands');
Tcell = regexp(T, '\n', 'split');
set(handles.text38,'String',Tcell);
%call swath plotter sub-GUI
swath_plotter

%% SH filter sub-GUI call button
function pushbutton42_Callback(hObject, eventdata, handles)
    %promt information
    Commands=('This routine allows improving interpolations between shoreline angles by removing outliers. Shoreline angles should be projected before proceed. Interpolations and outliers can be saved.');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
cd(handles.stationsdir) 
file=('sh_projected.txt');

if exist(file,'file')==1 || exist(file,'file')==2;
fid=fopen(file,'r');
i=1;
while ~feof(fid)
    A=textscan(fid,'%u %u %u %u/','delimiter',' ','HeaderLines',1);
    
    for j=1:4 %number of columns (default from shorelines.txt)
        data(i,j) = A(1,j);
    end
    i=i+1;
end
%This function can run only if the number of extracted shoreline-angles is
%higher than 10
 if numel(data(:,1))>=10;
  SH_filter;  
 else
 %promt information
    Commands=('Insuficient shorelines have been mapped for the analysis, minimum 10 shoreline angles');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);      
 end
end
 
%% project difussion values routine
function difuse_analysis_Callback(hObject, eventdata, handles)
cd(handles.stationsdir)
station=handles.statsel;
cd(station)

if exist(sprintf('%s_diffusion.mat',station))==0
disp('No diffusion calculated yet')   
%promt information
    Commands=('No difussion values have been analyzed yet');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
else    
%load difussion secondary table
load(sprintf('%s_diffusion.mat',station))
figure
ax1=subplot(2,1,1:2);
% set variables 
x=DIFFUSION(:,2);
y=DIFFUSION(:,3);
z=DIFFUSION(:,4);
ze=DIFFUSION(:,5);
dif=DIFFUSION(:,6);
rms=DIFFUSION(:,7);
a=DIFFUSION(:,8);
%plot values for projection
hold on
scatter(x,y,100,dif,'filled');
col=colorbar;
tite = get(col,'title');
set(tite,'string','KT (m^2)');
axis equal
box on
ylabel('UTM   N')
xlabel('UTM   E')
%graphic input profile
[xl,yl]=ginput(2);
l(:,1)=xl;
l(:,2)=yl;
plot(xl,yl,'-k') %plot of profile
plot(l(1,1),l(1,2),'or'); %point1
plot(l(2,1),l(2,2),'ob'); %point2
%angle of profile
dx=l(1,1)-l(2,1);
dy=l(1,2)-l(2,2);
m=(dy/dx);
m2=-1/m;
an=-atan(m)*180/pi;
anr=an*pi/180;
ddg=sqrt((l(1,1)-l(2,1))^2+(l(1,2)-l(2,2))^2);
dkm=(ddg);
b=l(1,2)-m*l(1,1);
%text in plot
str1=num2str(dkm/1000); %m to km
text(min(xl)+(dx/2),min(yl)+(dy/2),sprintf('%s km',str1),'FontSize',12)
%rotate and reproject data

for i=1:length(x(:,1))
    b2=y(i)-m2*x(i);
    Pnx=(b2-b)/(m-m2);
    Pny=m*Pnx+b;
    Pn=[Pnx Pny];
    dp(i,1)=Pn(1,1); %xp
    dp(i,2)=Pn(1,2); %yp
    dp(i,3)=((l(1,2)-dp(i,2))/sin(anr)); % distance in km
    dp(i,4)=z(i);
    dp(i,5)=ze(i);
    dp(i,6)=dif(i);
    dp(i,7)=rms(i);
    dp(i,8)=a(i);
end
%plot projected Kt values
figure(2)
clf
subplot(2,1,1)
hold on
box on
scatter(dp(:,3),dp(:,6),60,dif,'filled');
plot(dp(:,3),dp(:,6),'o')
%cartesian plane conditions for profiles
if dx>0 && dy>0   
xlim([-dkm/1000 0])
a=1; %a is a parameter for data export
elseif dx<0 && dy<0 
xlim([0 dkm/1000])    
a=3;
elseif dx>0 && dy<0  
xlim([-dkm/1000 0]) 
a=4;
else
a=2;
xlim([0 dkm/1000]) 
end
ylabel('Elevation (m)')
xlabel('Distance along profile (km)')
end

%% Point projection sub-GUI call button
function projection_button_Callback(hObject, eventdata, handles)
%promt information
    Commands=('Shoreline angles can be projected along custom lines or profiles. User defines the line by two points, or using a ESRI(R) shapefile containing the profile.');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
%set directories
cd(handles.stationsdir)
file=('shorelines.txt');

if exist(file,'file')==1 || exist(file,'file')==2 
%load shorelines table
fid=fopen(file,'r');
i=1;
while ~feof(fid)
    A=textscan(fid,'%s %u %u %f %f %f %f %f %s %f/','delimiter',' ','HeaderLines',1);    
    for j=1:10 %number of columns (default from shorelines.txt)
        data(i,j) = A(1,j);
    end
    i=i+1;
end
if numel(data(:,1))>=10
SH_projection
else 
    %promt information
    Commands=('Insuficient shorelines');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell); 
    
end
end

%% Shoreline restoration calllback button
function restoration_Callback(hObject, eventdata, handles)

Commands=('Shoreline angles can be restored if the table shorelines.txt is corrupt or accidentally deleted');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);

%set directories
cd(handles.stationsdir)
stationsel=handles.statsel;

prompt={'Please type the station name to restore'};
name = 'Theta Value';
%defaultans = {'30'};
defaultans = {stationsel};
%options.Interpreter = 'tex';
answer = inputdlg(prompt,name,[1 20],defaultans);

%duplicate shorelines.txt
movefile('shorelines.txt','shorelines_before_restoration.txt')

%create new empty shorelines with header
file=('shorelines.txt');
fid = fopen(file, 'a');     
fprintf(fid,'Station Profile_number shoreline_number east north distance_along_swath shoreline_elevation error analysis_type time');
fclose(fid);
type 'shorelines.txt' 

%change to stations folder
station=char(answer);
try
cd(station)
catch
    msgbox('No Station marked')
end
%load inputs from station folder
load(sprintf('%s_Clicks',station));
load(sprintf('%s_swaths',station));

%detect profiles in input
name_prof=fieldnames(Clicks);
k=1;
%extract profiles numbers
for i=1:numel(name_prof)
    try %error catch for 'stacks' contained within profiles structures
name_shore1(k,:)=(fieldnames(Clicks.(name_prof{i,1})));
    catch
  disp('')      
    end
shore_clean=name_shore1(~cellfun('isempty',name_shore1));      
name_shore=unique(shore_clean);
IndexC = strfind(name_shore,'stack');

Index = find(not(cellfun('isempty', IndexC)));
name_shore(Index)=[];

%isolate profile number
remain1=strtok(name_prof{i,:},'prof_');
prof_list(k,1)=str2num(remain1); %find another way to delete the _ % its deletes the 0 in 10
k=k+1;
end

%extract shorelines numbers
clear k
k=1;
for j=1:numel(name_shore)   
%isolate shore number
remain2=strtok(name_shore{j,1},'shore_');
shore_list(k,1)=str2num(remain2);

k=k+1;
end

clear token1 remain1 token2 remain2 

%check again uniqueness before big loop
prof_l=unique(prof_list);
shore_l=unique(shore_list)


%big loop explore combinations between shorelines and profiles to detect
%previously mapped shoreline angles

for i1=1:numel(prof_l) %loop profile numbers
    p=prof_l(i1,1);
    
for i2=1:numel(shore_l) %loop shorelines numbers
    s=shore_l(i2,1);
      
    %STAIRCASE analysis checker
    doesVarExist = true;
    try
    Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).class;
    catch
    doesVarExist = false;
    end
    
if doesVarExist == 1; %exist combination
    
    %inputs for sfitprof
    swat=eval(sprintf('swat%u',p));
    pto=eval(sprintf('pto%u',p));
    thetaB=eval(sprintf('thetaB%u',p));
    Dprof=eval(sprintf('Dprof%u',p));
    batchmode='1'; %allways set to 1 when using inputset mode
    
    %extract user points from Clicks   
    clif=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).class.clif;
    plat=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).class.plat;    
    
    %call sfitprof in special mode
    shoreline=Terracem_sfitprof(swat,station,p,s,pto,thetaB,Dprof,batchmode,clif,plat);
    
cd(handles.stationsdir)
    %Read table file and save shoreline output
    file=('shorelines.txt');
        fid = fopen(file, 'a');    
        fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f staircase %8.5f',station,p,shoreline,now);    
    fclose(fid);
    type 'shorelines.txt'   
cd(station)   
 
 
end

    %check for fixed cliff analysis
    doesVarExist2 = true;
    try
    Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).fix;
    catch
    doesVarExist2 = false;        
    end
    
    %load fix  
    if doesVarExist2 == 1; 
    
    %extract data    
    clif=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).fix.clif;
    plat=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).fix.plat;
    
    %inputs for fix cliff
    swat=eval(sprintf('swat%u',p));
    pto=eval(sprintf('pto%u',p));
    thetaB=eval(sprintf('thetaB%u',p));
    Dprof=eval(sprintf('Dprof%u',p));
    
    %inputs from structure
    slo=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).fix.inputs.slo;
    ra=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).fix.inputs.ra;
    
    %call fixed cliff
    shoreline=Terracem_fxcliff(swat,station,p,s,pto,thetaB,Dprof,slo,ra,clif,plat); 
    
cd(handles.stationsdir)
    %Read data file 
  file=('shorelines.txt');
        fid = fopen(file, 'a');    
        fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f fix %8.5f',station,p,shoreline,now);    
    fclose(fid);
    type 'shorelines.txt'   
 cd(station)   

    end
    
     %check for diffussion analysis
    doesVarExist3 = true;
    try
    Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff;
    catch
    doesVarExist3 = false;        
    end
    
     %load diff  
    if doesVarExist3 == 1; 
    
        %extract data    
    tops=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.tops;
    bots=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.bots;
    scarp=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.scarp;
    
    %inputs for diff cliff
    swat=eval(sprintf('swat%u',p));
    pto=eval(sprintf('pto%u',p));
    thetaB=eval(sprintf('thetaB%u',p));
    Dprof=eval(sprintf('Dprof%u',p));
    
    %inputs form structure
    thetadegrees=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.inputs.thetadegrees;
    k=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.inputs.k;
    t1=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.inputs.t1;
    ti=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.inputs.ti;
    t2=Clicks.(sprintf('prof_%u',p)).(sprintf('shore_%u',s)).diff.inputs.t2;
   
        
    [shoreline Difusion]=Terracem_terracediff(swat,station,p,s,pto,thetaB,Dprof,thetadegrees,k,t1,ti,t2,tops,bots,scarp);    
cd(handles.stationsdir) 
    %Read outputs table file 
    file=('shorelines.txt');
    fid = fopen(file, 'a');    
    fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f diffusion %8.5f',station,p,shoreline,now);    
    fclose(fid);
    
 cd(station)        
    end
 
    
    
end

    %STACK analysis checker
    doesVarExist4 = true;
    try
    Clicks.(sprintf('prof_%u',p)).stack;
    catch
    doesVarExist4 = false;        
    end
    
      if doesVarExist4 == 1; %true
    
    %inputs for stack
    swat=eval(sprintf('swat%u',p));
    pto=eval(sprintf('pto%u',p));
    thetaB=eval(sprintf('thetaB%u',p));
    Dprof=eval(sprintf('Dprof%u',p)); 
    
    %inputs comming from structure
    peak=Clicks.(sprintf('prof_%u',p)).stack.inputs.peak;
          
    %extract data 
    quad=Clicks.(sprintf('prof_%u',p)).stack.quad;
    X=Clicks.(sprintf('prof_%u',p)).stack.XY(:,1);    
    Y=Clicks.(sprintf('prof_%u',p)).stack.XY(:,2);  
    
    if isempty(Clicks.(sprintf('prof_%u',p)).stack.XSYS)==1
            XSYS=[];
            else              
            XSYS=Clicks.(sprintf('prof_%u',p)).stack.XSYS;
    end
    
    
    
    [stacks]=Terracem_stacks(swat,station,p,pto,thetaB,Dprof,peak,quad,X,Y,XSYS);
    numb=numel(stacks(:,1)); 
    
cd(handles.stationsdir)
    
    try
    file=('shorelines.txt'); 
    %
    for i=1:numb;    
    fid = fopen(file, 'a');    
    fprintf(fid,'\n%s %u %u %6.0f %7.0f %5.2f %4.2f %4.2f stack %8.5f',station,p,stacks(i,:),now);
    end
    %
    fclose(fid);
    catch
    disp('Impossible to save stack shorelines')
    end
     cd(station) 
    
      end


end

cd(handles.maindir)
msgbox(sprintf('Restoration of %s shorelines is done, check your stations folder',station))


%% Nested functions %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Function 1: myTable
function myTable(file,cnames) 
%Inputs:
%table shorelines in each stations directory
%stations name

h = figure('Position',[600 400 902 600],'numbertitle','off','MenuBar','none','ToolBar','none');
%Data input, read shorelines table
%defaultData = rand(90,10); %test default
%cd(handles.stationsdir)
%file=('shorelines.txt');
if exist(file,'file')==1 || exist(file,'file')==2    
%load shorelines table
fid=fopen(file,'r');
i=1;
while ~feof(fid)
    %tline = fgetl(fid);
    A=textscan(fid,'%s %u %u %f %f %f %f %f %s %f/','delimiter',' ','HeaderLines',1);
    %works with this weird / 
    %check headerlines
    
    for j=1:10 %number of columns (default)
        data(i,j) = A(1,j);
    end
    i=i+1;
end

fclose(fid);
data=sortrows(data,10);
nim=numel(data(:,10));
u=1;

for k=1:nim
t1(u,:)=cellstr(data{k,1}); %station
t2(u,:)=(data(k,2));
t3(u,:)=data(k,3);
t4(u,:)=data(k,4);
t5(u,:)=data(k,5);
t6(u,:)=(data(k,6));
t7(u,:)=data(k,7);
t8(u,:)=data(k,8);
t9(u,:)=cellstr(data{k,9}); % type analysis
t10(u,:)=(data(k,10));
u=1+u;
end

defaultData=horzcat(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10);

% Digital table creation
%cnames = {'Station', 'Profile_number', 'shoreline_number', 'east', 'north', 'distance_along_swath', 'shoreline_elevation', 'error', 'analysis_type', 'time'};%colun names

uitable(h,'Units','normalized','Position',[0 0 1 1],...
              'Data', defaultData,... 
              'Tag','myTable',...    
              'ColumnName', cnames,'RowName',[],...
              'CellSelectionCallback',@cellSelect);

% create pushbutton to delete selected rows
tb = uitoolbar(h);

%icon colors for delete button
a = [.20:.05:0.95];
b(:,:,1) = repmat(a,16,1)';
b(:,:,2) = repmat(a,16,1);
b(:,:,3) = repmat(flipdim(a,2),16,1);

uipushtool(tb,'CData',b,'tooltipstring','delete','ClickedCallback',@deleteRow);


end

%% Function 2: select cell
function cellSelect(src,evt)
% get indices of selected rows and make them available for other callbacks
index = evt.Indices;
if any(index)             %loop necessary to surpress unimportant errors.
    rows = index(:,1);
    set(src,'UserData',rows);
end

%% Function 3: celldelete row
function deleteRow(~,~)
th = findobj('Tag','myTable');
% get current data
data1 = get(th,'Data');
% get indices of selected rows
rows = get(th,'UserData');
% create mask containing rows to keep
mask = (1:size(data1,1))';
mask(rows) = [];
% delete selected rows and re-write data
data1 = data1(mask,:);
set(th,'Data',data1);

%save data1 to .txt table


  dlmcell('shorelines.txt',data1,'delimiter',' '); 


%% Function 4: dlmcell
function dlmcell(file,cell_array,varargin) 
% dlmcell - Write Cell Array to Text File     
%                                                 Version:    01.06.2010 
%                                                     (c) Roland Pfister 
%                                             roland_pfister@t-online.de 
%                        ...with many thanks to George Papazafeiropoulos 
%                        for his corrections and improvements.           
% 1. Synopsis                                                            
%                                                                        
% A single cell array is written to an output file. Cells may consist of 
% any combination of (a) numbers, (b) letters, or (c) words. The inputs  
% are as follows:                                                        
%                                                                        
%       - file       The output filename (string).                       
%       - cell_array The cell array to be written.                       
%       - delimiter  Delimiter symbol, e.g. ',' (optional;               
%                    default: tab ('\t'}).                               
%       - append     '-a' for appending the content to the               
%                    output file (optional).                             
% Check input arguments
if nargin < 2
    disp('Error - Give at least two input arguments!');
    Commands=('Error- Give at leat three input arguments');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    
    return;
elseif nargin > 4
    disp('Error - Do not give more than 4 input arguments!');
    
    Commands=('Error -  Dont give more than four input arguments');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    
    return;
end
if ~ischar(file)
    disp(['Error - File input has to be a string (e.g. ' ...
        char(39) 'output.txt' char(39) '!']);
    
    Commands=('Error - File input has to be a string');
    T = evalc('Commands');
    Tcell = regexp(T, '\n', 'split');
    set(handles.text38,'String',Tcell);
    
    return;
end;
if ~iscell(cell_array)
    disp('Error - Input cell_array not of the type "cell"!');
    return;
end;
delimiter = '\t';
append = 'w';
if nargin > 2
    for i = 1:size(varargin,2)
        if strcmp('-a',varargin{1,i}) == 1
            append = 'a';
        else
            delimiter = varargin{1,i};
        end;
    end;
end

%Open output file and prepare output array.
output_file = fopen(file,append);
output = cell(size(cell_array,1),size(cell_array,2));

%Evaluate and write input array.
for i = 1:size(cell_array,1)
    for j = 1:size(cell_array,2)
        if numel(cell_array{i,j}) == 0
            output{i,j} = '';
            % Check whether the content of cell i,j is
            % numeric and convert numbers to strings.
        elseif isnumeric(cell_array{i,j}) || islogical(cell_array{i,j})
            output{i,j} = num2str(cell_array{i,j}(1,1));
            
            % Check whether the content of cell i,j is another cell (e.g. a
            % string of length > 1 that was stored as cell. If cell sizes
            % equal [1,1], convert numbers and char-cells to strings.
            % Note that any other cells-within-the-cell will produce errors
            % or wrong results.
        elseif iscell(cell_array{i,j})
            if size(cell_array{i,j},1) == 1 && size(cell_array{i,j},1) == 1
                if isnumeric(cell_array{i,j}{1,1})
                    output{i,j} = num2str(cell_array{i,j}{1,1}(1,1));
                elseif ischar(cell_array{i,j}{1,1})
                    output{i,j} = cell_array{i,j}{1,1};
                end;
            end;
            
            % If the cell already contains a string, nothing has to be done.
        elseif ischar(cell_array{i,j})
            output{i,j} = cell_array{i,j};
        end;        
        % Cell i,j is written to the output file. A delimiter is appended for
        % all but the last element of each row. At the end of a row, a newline
        % is written to the output file.
        if j < size(cell_array,2)
            fprintf(output_file,['%s',delimiter],output{i,j});
        else
            fprintf(output_file,'%s\r\n',output{i,j});
        end
    end;
end;

% Close output file.
fclose(output_file);
