function point2utm=Terracem_point2utm(p1,pto, thetaB, Dprof, type_profile)
%Function to convert profile points to utm coordinates based on the
%geometry of the rectangular profile (swath area)
%pto=red point for orienttion of profile
%p1=calculated shoreline angle in profile
%pto, thetaB, and Dprof comes from extract swats
%type_profile comes from each analysis functions (sfitprof,
%terracediff and stacks)
%Jara & Melnick 2014

dprof=Dprof;
scarp=p1;
%CASE(1) for non-flipped profiles
if type_profile==1 
x1pto=pto(1,1);
y1pto=pto(1,2);
if (thetaB<90) && (thetaB>0) %|| (thetaB>173.7)&& (thetaB<180)   
x2pto=pto(1,1)+((dprof)*cosd(thetaB));
y2pto=pto(1,2)+((dprof)*sind(thetaB));
% rectangle axis pairs for analysis
px1(1,1)=x1pto;
px1(1,2)=x2pto;
py1(1,1)=y1pto;
py1(1,2)=y2pto;     
Rx= (scarp(1,1)/dprof) * (px1(1,2)-px1(1,1)) + px1(1,1); %x for 0 - 90?
Ry= (scarp(1,1)/dprof) * (py1(1,2)-py1(1,1)) + py1(1,1); %y    
elseif (thetaB>173.7) && (thetaB<180)
x2pto=-((dprof)*cosd(thetaB))+pto(1,1);
y2pto=-((dprof)*sind(thetaB))+pto(1,2);
% rectangle axis pairs for analysis
px1(1,1)=x1pto;
px1(1,2)=x2pto;
py1(1,1)=y1pto;
py1(1,2)=y2pto;  
scarp2=scarp(1,1);
Rx= (scarp2(1,1)/dprof) * (px1(1,2)-px1(1,1)) + px1(1,1); %x for 180 - 173.7?
Ry= (scarp2(1,1)/dprof) * (py1(1,2)-py1(1,1)) + py1(1,1); %y       
else %(thetaB<180) && (thetaB>90) 
scarp1=dprof-scarp(1,1);% Modified scarp position for NW oriented profiles
x2pto=pto(1,1)-((dprof)*cosd(thetaB));
y2pto=pto(1,2)-((dprof)*sind(thetaB)); 
% rectangle axis pairs for analysis
px1(1,1)=x1pto; 
px1(1,2)=x2pto;
py1(1,1)=y1pto; py1(1,2)=y2pto;      
Rx= (scarp1(1,1)/dprof) * (px1(1,1)-px1(1,2)) + px1(1,1); %x for 90 - 180?
Ry= (scarp1(1,1)/dprof) * (py1(1,1)-py1(1,2)) + py1(1,1); %y     
end
%CASE(2) for flipped profiles
else
x2pto=pto(1,1);
y2pto=pto(1,2);
scarp_pre=scarp(1,1);
if (thetaB<90) && (thetaB>0)         
x1pto=pto(1,1)+((dprof)*cosd(thetaB));
y1pto=pto(1,2)+((dprof)*sind(thetaB));
% rectangle axis pairs for analysis
px1(1,1)=x1pto;px1(1,2)=x2pto;
py1(1,1)=y1pto;py1(1,2)=y2pto;    
Rx= (scarp_pre(1,1)/dprof) * (px1(1,2)-px1(1,1)) + px1(1,1); %x for 0 - 90?
Ry= (scarp_pre(1,1)/dprof) * (py1(1,2)-py1(1,1)) + py1(1,1); %y        
else %(thetaB<180) && (thetaB>90)     
x1pto=pto(1,1);
y1pto=pto(1,2);         
x2pto=pto(1,1)-((dprof)*cosd(thetaB));
y2pto=pto(1,2)-((dprof)*sind(thetaB)); 
% rectangle axis pairs for analysis
px1(1,1)=x1pto; 
px1(1,2)=x2pto;
py1(1,1)=y1pto; 
py1(1,2)=y2pto;  
scarp1=dprof-scarp(1,1);
Rx= (scarp1(1,1)/dprof) * (px1(1,1)-px1(1,2)) + px1(1,1); %x for 90 - 180?
Ry= (scarp1(1,1)/dprof) * (py1(1,1)-py1(1,2)) + py1(1,1); %y     
end    
end 
%outputs in utm coordinates
Rz=p1(1,2); %z value for input point 
point2utm=[Rx Ry Rz];    